t/perf: avoid unnecessary test_export() recursion
[git] / t / test-lib.sh
1 # Test framework for git.  See t/README for usage.
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
17
18 # Test the binaries we have just built.  The tests are kept in
19 # t/ subdirectory and are run in 'trash directory' subdirectory.
20 if test -z "$TEST_DIRECTORY"
21 then
22         # We allow tests to override this, in case they want to run tests
23         # outside of t/, e.g. for running tests on the test library
24         # itself.
25         TEST_DIRECTORY=$(pwd)
26 else
27         # ensure that TEST_DIRECTORY is an absolute path so that it
28         # is valid even if the current working directory is changed
29         TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
30 fi
31 if test -z "$TEST_OUTPUT_DIRECTORY"
32 then
33         # Similarly, override this to store the test-results subdir
34         # elsewhere
35         TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
36 fi
37 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
38
39 # If we were built with ASAN, it may complain about leaks
40 # of program-lifetime variables. Disable it by default to lower
41 # the noise level. This needs to happen at the start of the script,
42 # before we even do our "did we build git yet" check (since we don't
43 # want that one to complain to stderr).
44 : ${ASAN_OPTIONS=detect_leaks=0:abort_on_error=1}
45 export ASAN_OPTIONS
46
47 # If LSAN is in effect we _do_ want leak checking, but we still
48 # want to abort so that we notice the problems.
49 : ${LSAN_OPTIONS=abort_on_error=1}
50 export LSAN_OPTIONS
51
52 if test ! -f "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
53 then
54         echo >&2 'error: GIT-BUILD-OPTIONS missing (has Git been built?).'
55         exit 1
56 fi
57 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
58 export PERL_PATH SHELL_PATH
59
60 # Disallow the use of abbreviated options in the test suite by default
61 if test -z "${GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS}"
62 then
63         GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS=true
64         export GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS
65 fi
66
67 ################################################################
68 # It appears that people try to run tests without building...
69 "${GIT_TEST_INSTALLED:-$GIT_BUILD_DIR}/git$X" >/dev/null
70 if test $? != 1
71 then
72         if test -n "$GIT_TEST_INSTALLED"
73         then
74                 echo >&2 "error: there is no working Git at '$GIT_TEST_INSTALLED'"
75         else
76                 echo >&2 'error: you do not seem to have built git yet.'
77         fi
78         exit 1
79 fi
80
81 store_arg_to=
82 opt_required_arg=
83 # $1: option string
84 # $2: name of the var where the arg will be stored
85 mark_option_requires_arg () {
86         if test -n "$opt_required_arg"
87         then
88                 echo "error: options that require args cannot be bundled" \
89                         "together: '$opt_required_arg' and '$1'" >&2
90                 exit 1
91         fi
92         opt_required_arg=$1
93         store_arg_to=$2
94 }
95
96 parse_option () {
97         local opt="$1"
98
99         case "$opt" in
100         -d|--d|--de|--deb|--debu|--debug)
101                 debug=t ;;
102         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
103                 immediate=t ;;
104         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
105                 GIT_TEST_LONG=t; export GIT_TEST_LONG ;;
106         -r)
107                 mark_option_requires_arg "$opt" run_list
108                 ;;
109         --run=*)
110                 run_list=${opt#--*=} ;;
111         -h|--h|--he|--hel|--help)
112                 help=t ;;
113         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
114                 verbose=t ;;
115         --verbose-only=*)
116                 verbose_only=${opt#--*=}
117                 ;;
118         -q|--q|--qu|--qui|--quie|--quiet)
119                 # Ignore --quiet under a TAP::Harness. Saying how many tests
120                 # passed without the ok/not ok details is always an error.
121                 test -z "$HARNESS_ACTIVE" && quiet=t ;;
122         --with-dashes)
123                 with_dashes=t ;;
124         --no-bin-wrappers)
125                 no_bin_wrappers=t ;;
126         --no-color)
127                 color= ;;
128         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
129                 valgrind=memcheck
130                 tee=t
131                 ;;
132         --valgrind=*)
133                 valgrind=${opt#--*=}
134                 tee=t
135                 ;;
136         --valgrind-only=*)
137                 valgrind_only=${opt#--*=}
138                 tee=t
139                 ;;
140         --tee)
141                 tee=t ;;
142         --root=*)
143                 root=${opt#--*=} ;;
144         --chain-lint)
145                 GIT_TEST_CHAIN_LINT=1 ;;
146         --no-chain-lint)
147                 GIT_TEST_CHAIN_LINT=0 ;;
148         -x)
149                 trace=t ;;
150         -V|--verbose-log)
151                 verbose_log=t
152                 tee=t
153                 ;;
154         --write-junit-xml)
155                 write_junit_xml=t
156                 ;;
157         --stress)
158                 stress=t ;;
159         --stress=*)
160                 echo "error: --stress does not accept an argument: '$opt'" >&2
161                 echo "did you mean --stress-jobs=${opt#*=} or --stress-limit=${opt#*=}?" >&2
162                 exit 1
163                 ;;
164         --stress-jobs=*)
165                 stress=t;
166                 stress=${opt#--*=}
167                 case "$stress" in
168                 *[!0-9]*|0*|"")
169                         echo "error: --stress-jobs=<N> requires the number of jobs to run" >&2
170                         exit 1
171                         ;;
172                 *)      # Good.
173                         ;;
174                 esac
175                 ;;
176         --stress-limit=*)
177                 stress=t;
178                 stress_limit=${opt#--*=}
179                 case "$stress_limit" in
180                 *[!0-9]*|0*|"")
181                         echo "error: --stress-limit=<N> requires the number of repetitions" >&2
182                         exit 1
183                         ;;
184                 *)      # Good.
185                         ;;
186                 esac
187                 ;;
188         *)
189                 echo "error: unknown test option '$opt'" >&2; exit 1 ;;
190         esac
191 }
192
193 # Parse options while taking care to leave $@ intact, so we will still
194 # have all the original command line options when executing the test
195 # script again for '--tee' and '--verbose-log' later.
196 for opt
197 do
198         if test -n "$store_arg_to"
199         then
200                 eval $store_arg_to=\$opt
201                 store_arg_to=
202                 opt_required_arg=
203                 continue
204         fi
205
206         case "$opt" in
207         --*|-?)
208                 parse_option "$opt" ;;
209         -?*)
210                 # bundled short options must be fed separately to parse_option
211                 opt=${opt#-}
212                 while test -n "$opt"
213                 do
214                         extra=${opt#?}
215                         this=${opt%$extra}
216                         opt=$extra
217                         parse_option "-$this"
218                 done
219                 ;;
220         *)
221                 echo "error: unknown test option '$opt'" >&2; exit 1 ;;
222         esac
223 done
224 if test -n "$store_arg_to"
225 then
226         echo "error: $opt_required_arg requires an argument" >&2
227         exit 1
228 fi
229
230 if test -n "$valgrind_only"
231 then
232         test -z "$valgrind" && valgrind=memcheck
233         test -z "$verbose" && verbose_only="$valgrind_only"
234 elif test -n "$valgrind"
235 then
236         test -z "$verbose_log" && verbose=t
237 fi
238
239 if test -n "$stress"
240 then
241         verbose=t
242         trace=t
243         immediate=t
244 fi
245
246 TEST_STRESS_JOB_SFX="${GIT_TEST_STRESS_JOB_NR:+.stress-$GIT_TEST_STRESS_JOB_NR}"
247 TEST_NAME="$(basename "$0" .sh)"
248 TEST_NUMBER="${TEST_NAME%%-*}"
249 TEST_NUMBER="${TEST_NUMBER#t}"
250 TEST_RESULTS_DIR="$TEST_OUTPUT_DIRECTORY/test-results"
251 TEST_RESULTS_BASE="$TEST_RESULTS_DIR/$TEST_NAME$TEST_STRESS_JOB_SFX"
252 TRASH_DIRECTORY="trash directory.$TEST_NAME$TEST_STRESS_JOB_SFX"
253 test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
254 case "$TRASH_DIRECTORY" in
255 /*) ;; # absolute path is good
256  *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
257 esac
258
259 # If --stress was passed, run this test repeatedly in several parallel loops.
260 if test "$GIT_TEST_STRESS_STARTED" = "done"
261 then
262         : # Don't stress test again.
263 elif test -n "$stress"
264 then
265         if test "$stress" != t
266         then
267                 job_count=$stress
268         elif test -n "$GIT_TEST_STRESS_LOAD"
269         then
270                 job_count="$GIT_TEST_STRESS_LOAD"
271         elif job_count=$(getconf _NPROCESSORS_ONLN 2>/dev/null) &&
272              test -n "$job_count"
273         then
274                 job_count=$((2 * $job_count))
275         else
276                 job_count=8
277         fi
278
279         mkdir -p "$TEST_RESULTS_DIR"
280         stressfail="$TEST_RESULTS_BASE.stress-failed"
281         rm -f "$stressfail"
282
283         stress_exit=0
284         trap '
285                 kill $job_pids 2>/dev/null
286                 wait
287                 stress_exit=1
288         ' TERM INT HUP
289
290         job_pids=
291         job_nr=0
292         while test $job_nr -lt "$job_count"
293         do
294                 (
295                         GIT_TEST_STRESS_STARTED=done
296                         GIT_TEST_STRESS_JOB_NR=$job_nr
297                         export GIT_TEST_STRESS_STARTED GIT_TEST_STRESS_JOB_NR
298
299                         trap '
300                                 kill $test_pid 2>/dev/null
301                                 wait
302                                 exit 1
303                         ' TERM INT
304
305                         cnt=1
306                         while ! test -e "$stressfail" &&
307                               { test -z "$stress_limit" ||
308                                 test $cnt -le $stress_limit ; }
309                         do
310                                 $TEST_SHELL_PATH "$0" "$@" >"$TEST_RESULTS_BASE.stress-$job_nr.out" 2>&1 &
311                                 test_pid=$!
312
313                                 if wait $test_pid
314                                 then
315                                         printf "OK   %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
316                                 else
317                                         echo $GIT_TEST_STRESS_JOB_NR >>"$stressfail"
318                                         printf "FAIL %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
319                                 fi
320                                 cnt=$(($cnt + 1))
321                         done
322                 ) &
323                 job_pids="$job_pids $!"
324                 job_nr=$(($job_nr + 1))
325         done
326
327         wait
328
329         if test -f "$stressfail"
330         then
331                 stress_exit=1
332                 echo "Log(s) of failed test run(s):"
333                 for failed_job_nr in $(sort -n "$stressfail")
334                 do
335                         echo "Contents of '$TEST_RESULTS_BASE.stress-$failed_job_nr.out':"
336                         cat "$TEST_RESULTS_BASE.stress-$failed_job_nr.out"
337                 done
338                 rm -rf "$TRASH_DIRECTORY.stress-failed"
339                 # Move the last one.
340                 mv "$TRASH_DIRECTORY.stress-$failed_job_nr" "$TRASH_DIRECTORY.stress-failed"
341         fi
342
343         exit $stress_exit
344 fi
345
346 # if --tee was passed, write the output not only to the terminal, but
347 # additionally to the file test-results/$BASENAME.out, too.
348 if test "$GIT_TEST_TEE_STARTED" = "done"
349 then
350         : # do not redirect again
351 elif test -n "$tee"
352 then
353         mkdir -p "$TEST_RESULTS_DIR"
354
355         # Make this filename available to the sub-process in case it is using
356         # --verbose-log.
357         GIT_TEST_TEE_OUTPUT_FILE=$TEST_RESULTS_BASE.out
358         export GIT_TEST_TEE_OUTPUT_FILE
359
360         # Truncate before calling "tee -a" to get rid of the results
361         # from any previous runs.
362         >"$GIT_TEST_TEE_OUTPUT_FILE"
363
364         (GIT_TEST_TEE_STARTED=done ${TEST_SHELL_PATH} "$0" "$@" 2>&1;
365          echo $? >"$TEST_RESULTS_BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
366         test "$(cat "$TEST_RESULTS_BASE.exit")" = 0
367         exit
368 fi
369
370 if test -n "$trace" && test -n "$test_untraceable"
371 then
372         # '-x' tracing requested, but this test script can't be reliably
373         # traced, unless it is run with a Bash version supporting
374         # BASH_XTRACEFD (introduced in Bash v4.1).
375         #
376         # Perform this version check _after_ the test script was
377         # potentially re-executed with $TEST_SHELL_PATH for '--tee' or
378         # '--verbose-log', so the right shell is checked and the
379         # warning is issued only once.
380         if test -n "$BASH_VERSION" && eval '
381              test ${BASH_VERSINFO[0]} -gt 4 || {
382                test ${BASH_VERSINFO[0]} -eq 4 &&
383                test ${BASH_VERSINFO[1]} -ge 1
384              }
385            '
386         then
387                 : Executed by a Bash version supporting BASH_XTRACEFD.  Good.
388         else
389                 echo >&2 "warning: ignoring -x; '$0' is untraceable without BASH_XTRACEFD"
390                 trace=
391         fi
392 fi
393 if test -n "$trace" && test -z "$verbose_log"
394 then
395         verbose=t
396 fi
397
398 # For repeatability, reset the environment to known value.
399 # TERM is sanitized below, after saving color control sequences.
400 LANG=C
401 LC_ALL=C
402 PAGER=cat
403 TZ=UTC
404 export LANG LC_ALL PAGER TZ
405 EDITOR=:
406
407 # GIT_TEST_GETTEXT_POISON should not influence git commands executed
408 # during initialization of test-lib and the test repo. Back it up,
409 # unset and then restore after initialization is finished.
410 if test -n "$GIT_TEST_GETTEXT_POISON"
411 then
412         GIT_TEST_GETTEXT_POISON_ORIG=$GIT_TEST_GETTEXT_POISON
413         unset GIT_TEST_GETTEXT_POISON
414 fi
415
416 # A call to "unset" with no arguments causes at least Solaris 10
417 # /usr/xpg4/bin/sh and /bin/ksh to bail out.  So keep the unsets
418 # deriving from the command substitution clustered with the other
419 # ones.
420 unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
421         my @env = keys %ENV;
422         my $ok = join("|", qw(
423                 TRACE
424                 DEBUG
425                 TEST
426                 .*_TEST
427                 PROVE
428                 VALGRIND
429                 UNZIP
430                 PERF_
431                 CURL_VERBOSE
432                 TRACE_CURL
433         ));
434         my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
435         print join("\n", @vars);
436 ')
437 unset XDG_CACHE_HOME
438 unset XDG_CONFIG_HOME
439 unset GITPERLLIB
440 TEST_AUTHOR_LOCALNAME=author
441 TEST_AUTHOR_DOMAIN=example.com
442 GIT_AUTHOR_EMAIL=${TEST_AUTHOR_LOCALNAME}@${TEST_AUTHOR_DOMAIN}
443 GIT_AUTHOR_NAME='A U Thor'
444 GIT_AUTHOR_DATE='1112354055 +0200'
445 TEST_COMMITTER_LOCALNAME=committer
446 TEST_COMMITTER_DOMAIN=example.com
447 GIT_COMMITTER_EMAIL=${TEST_COMMITTER_LOCALNAME}@${TEST_COMMITTER_DOMAIN}
448 GIT_COMMITTER_NAME='C O Mitter'
449 GIT_COMMITTER_DATE='1112354055 +0200'
450 GIT_MERGE_VERBOSITY=5
451 GIT_MERGE_AUTOEDIT=no
452 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
453 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
454 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
455 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
456 export EDITOR
457
458 GIT_DEFAULT_HASH="${GIT_TEST_DEFAULT_HASH:-sha1}"
459 export GIT_DEFAULT_HASH
460
461 # Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
462 GIT_TRACE_BARE=1
463 export GIT_TRACE_BARE
464
465 check_var_migration () {
466         # the warnings and hints given from this helper depends
467         # on end-user settings, which will disrupt the self-test
468         # done on the test framework itself.
469         case "$GIT_TEST_FRAMEWORK_SELFTEST" in
470         t)      return ;;
471         esac
472
473         old_name=$1 new_name=$2
474         eval "old_isset=\${${old_name}:+isset}"
475         eval "new_isset=\${${new_name}:+isset}"
476
477         case "$old_isset,$new_isset" in
478         isset,)
479                 echo >&2 "warning: $old_name is now $new_name"
480                 echo >&2 "hint: set $new_name too during the transition period"
481                 eval "$new_name=\$$old_name"
482                 ;;
483         isset,isset)
484                 # do this later
485                 # echo >&2 "warning: $old_name is now $new_name"
486                 # echo >&2 "hint: remove $old_name"
487                 ;;
488         esac
489 }
490
491 check_var_migration GIT_FSMONITOR_TEST GIT_TEST_FSMONITOR
492 check_var_migration TEST_GIT_INDEX_VERSION GIT_TEST_INDEX_VERSION
493 check_var_migration GIT_FORCE_PRELOAD_TEST GIT_TEST_PRELOAD_INDEX
494
495 # Use specific version of the index file format
496 if test -n "${GIT_TEST_INDEX_VERSION:+isset}"
497 then
498         GIT_INDEX_VERSION="$GIT_TEST_INDEX_VERSION"
499         export GIT_INDEX_VERSION
500 fi
501
502 # Add libc MALLOC and MALLOC_PERTURB test
503 # only if we are not executing the test with valgrind
504 if test -n "$valgrind" ||
505    test -n "$TEST_NO_MALLOC_CHECK"
506 then
507         setup_malloc_check () {
508                 : nothing
509         }
510         teardown_malloc_check () {
511                 : nothing
512         }
513 else
514         setup_malloc_check () {
515                 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
516                 export MALLOC_CHECK_ MALLOC_PERTURB_
517         }
518         teardown_malloc_check () {
519                 unset MALLOC_CHECK_ MALLOC_PERTURB_
520         }
521 fi
522
523 # Protect ourselves from common misconfiguration to export
524 # CDPATH into the environment
525 unset CDPATH
526
527 unset GREP_OPTIONS
528 unset UNZIP
529
530 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
531 1|2|true)
532         GIT_TRACE=4
533         ;;
534 esac
535
536 # Line feed
537 LF='
538 '
539
540 # Single quote
541 SQ=\'
542
543 # UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
544 # when case-folding filenames
545 u200c=$(printf '\342\200\214')
546
547 export _x05 _x35 _x40 _z40 LF u200c EMPTY_TREE EMPTY_BLOB ZERO_OID OID_REGEX
548
549 # Each test should start with something like this, after copyright notices:
550 #
551 # test_description='Description of this test...
552 # This test checks if command xyzzy does the right thing...
553 # '
554 # . ./test-lib.sh
555 test "x$TERM" != "xdumb" && (
556                 test -t 1 &&
557                 tput bold >/dev/null 2>&1 &&
558                 tput setaf 1 >/dev/null 2>&1 &&
559                 tput sgr0 >/dev/null 2>&1
560         ) &&
561         color=t
562
563 if test -n "$color"
564 then
565         # Save the color control sequences now rather than run tput
566         # each time say_color() is called.  This is done for two
567         # reasons:
568         #   * TERM will be changed to dumb
569         #   * HOME will be changed to a temporary directory and tput
570         #     might need to read ~/.terminfo from the original HOME
571         #     directory to get the control sequences
572         # Note:  This approach assumes the control sequences don't end
573         # in a newline for any terminal of interest (command
574         # substitutions strip trailing newlines).  Given that most
575         # (all?) terminals in common use are related to ECMA-48, this
576         # shouldn't be a problem.
577         say_color_error=$(tput bold; tput setaf 1) # bold red
578         say_color_skip=$(tput setaf 4) # blue
579         say_color_warn=$(tput setaf 3) # brown/yellow
580         say_color_pass=$(tput setaf 2) # green
581         say_color_info=$(tput setaf 6) # cyan
582         say_color_reset=$(tput sgr0)
583         say_color_="" # no formatting for normal text
584         say_color () {
585                 test -z "$1" && test -n "$quiet" && return
586                 eval "say_color_color=\$say_color_$1"
587                 shift
588                 printf "%s\\n" "$say_color_color$*$say_color_reset"
589         }
590 else
591         say_color() {
592                 test -z "$1" && test -n "$quiet" && return
593                 shift
594                 printf "%s\n" "$*"
595         }
596 fi
597
598 TERM=dumb
599 export TERM
600
601 error () {
602         say_color error "error: $*"
603         finalize_junit_xml
604         GIT_EXIT_OK=t
605         exit 1
606 }
607
608 BUG () {
609         error >&7 "bug in the test script: $*"
610 }
611
612 say () {
613         say_color info "$*"
614 }
615
616 if test -n "$HARNESS_ACTIVE"
617 then
618         if test "$verbose" = t || test -n "$verbose_only"
619         then
620                 printf 'Bail out! %s\n' \
621                  'verbose mode forbidden under TAP harness; try --verbose-log'
622                 exit 1
623         fi
624 fi
625
626 test "${test_description}" != "" ||
627 error "Test script did not set test_description."
628
629 if test "$help" = "t"
630 then
631         printf '%s\n' "$test_description"
632         exit 0
633 fi
634
635 exec 5>&1
636 exec 6<&0
637 exec 7>&2
638 if test "$verbose_log" = "t"
639 then
640         exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
641 elif test "$verbose" = "t"
642 then
643         exec 4>&2 3>&1
644 else
645         exec 4>/dev/null 3>/dev/null
646 fi
647
648 # Send any "-x" output directly to stderr to avoid polluting tests
649 # which capture stderr. We can do this unconditionally since it
650 # has no effect if tracing isn't turned on.
651 #
652 # Note that this sets up the trace fd as soon as we assign the variable, so it
653 # must come after the creation of descriptor 4 above. Likewise, we must never
654 # unset this, as it has the side effect of closing descriptor 4, which we
655 # use to show verbose tests to the user.
656 #
657 # Note also that we don't need or want to export it. The tracing is local to
658 # this shell, and we would not want to influence any shells we exec.
659 BASH_XTRACEFD=4
660
661 test_failure=0
662 test_count=0
663 test_fixed=0
664 test_broken=0
665 test_success=0
666
667 test_external_has_tap=0
668
669 die () {
670         code=$?
671         # This is responsible for running the atexit commands even when a
672         # test script run with '--immediate' fails, or when the user hits
673         # ctrl-C, i.e. when 'test_done' is not invoked at all.
674         test_atexit_handler || code=$?
675         if test -n "$GIT_EXIT_OK"
676         then
677                 exit $code
678         else
679                 echo >&5 "FATAL: Unexpected exit with code $code"
680                 exit 1
681         fi
682 }
683
684 GIT_EXIT_OK=
685 trap 'die' EXIT
686 # Disable '-x' tracing, because with some shells, notably dash, it
687 # prevents running the cleanup commands when a test script run with
688 # '--verbose-log -x' is interrupted.
689 trap '{ code=$?; set +x; } 2>/dev/null; exit $code' INT TERM HUP
690
691 # The user-facing functions are loaded from a separate file so that
692 # test_perf subshells can have them too
693 . "$TEST_DIRECTORY/test-lib-functions.sh"
694
695 # You are not expected to call test_ok_ and test_failure_ directly, use
696 # the test_expect_* functions instead.
697
698 test_ok_ () {
699         if test -n "$write_junit_xml"
700         then
701                 write_junit_xml_testcase "$*"
702         fi
703         test_success=$(($test_success + 1))
704         say_color "" "ok $test_count - $@"
705 }
706
707 test_failure_ () {
708         if test -n "$write_junit_xml"
709         then
710                 junit_insert="<failure message=\"not ok $test_count -"
711                 junit_insert="$junit_insert $(xml_attr_encode "$1")\">"
712                 junit_insert="$junit_insert $(xml_attr_encode \
713                         "$(if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
714                            then
715                                 test-tool path-utils skip-n-bytes \
716                                         "$GIT_TEST_TEE_OUTPUT_FILE" $GIT_TEST_TEE_OFFSET
717                            else
718                                 printf '%s\n' "$@" | sed 1d
719                            fi)")"
720                 junit_insert="$junit_insert</failure>"
721                 if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
722                 then
723                         junit_insert="$junit_insert<system-err>$(xml_attr_encode \
724                                 "$(cat "$GIT_TEST_TEE_OUTPUT_FILE")")</system-err>"
725                 fi
726                 write_junit_xml_testcase "$1" "      $junit_insert"
727         fi
728         test_failure=$(($test_failure + 1))
729         say_color error "not ok $test_count - $1"
730         shift
731         printf '%s\n' "$*" | sed -e 's/^/#      /'
732         test "$immediate" = "" || { finalize_junit_xml; GIT_EXIT_OK=t; exit 1; }
733 }
734
735 test_known_broken_ok_ () {
736         if test -n "$write_junit_xml"
737         then
738                 write_junit_xml_testcase "$* (breakage fixed)"
739         fi
740         test_fixed=$(($test_fixed+1))
741         say_color error "ok $test_count - $@ # TODO known breakage vanished"
742 }
743
744 test_known_broken_failure_ () {
745         if test -n "$write_junit_xml"
746         then
747                 write_junit_xml_testcase "$* (known breakage)"
748         fi
749         test_broken=$(($test_broken+1))
750         say_color warn "not ok $test_count - $@ # TODO known breakage"
751 }
752
753 test_debug () {
754         test "$debug" = "" || eval "$1"
755 }
756
757 match_pattern_list () {
758         arg="$1"
759         shift
760         test -z "$*" && return 1
761         for pattern_
762         do
763                 case "$arg" in
764                 $pattern_)
765                         return 0
766                 esac
767         done
768         return 1
769 }
770
771 match_test_selector_list () {
772         title="$1"
773         shift
774         arg="$1"
775         shift
776         test -z "$1" && return 0
777
778         # Both commas and whitespace are accepted as separators.
779         OLDIFS=$IFS
780         IFS='   ,'
781         set -- $1
782         IFS=$OLDIFS
783
784         # If the first selector is negative we include by default.
785         include=
786         case "$1" in
787                 !*) include=t ;;
788         esac
789
790         for selector
791         do
792                 orig_selector=$selector
793
794                 positive=t
795                 case "$selector" in
796                         !*)
797                                 positive=
798                                 selector=${selector##?}
799                                 ;;
800                 esac
801
802                 test -z "$selector" && continue
803
804                 case "$selector" in
805                         *-*)
806                                 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
807                                 then
808                                         echo "error: $title: invalid non-numeric in range" \
809                                                 "start: '$orig_selector'" >&2
810                                         exit 1
811                                 fi
812                                 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
813                                 then
814                                         echo "error: $title: invalid non-numeric in range" \
815                                                 "end: '$orig_selector'" >&2
816                                         exit 1
817                                 fi
818                                 ;;
819                         *)
820                                 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
821                                 then
822                                         echo "error: $title: invalid non-numeric in test" \
823                                                 "selector: '$orig_selector'" >&2
824                                         exit 1
825                                 fi
826                 esac
827
828                 # Short cut for "obvious" cases
829                 test -z "$include" && test -z "$positive" && continue
830                 test -n "$include" && test -n "$positive" && continue
831
832                 case "$selector" in
833                         -*)
834                                 if test $arg -le ${selector#-}
835                                 then
836                                         include=$positive
837                                 fi
838                                 ;;
839                         *-)
840                                 if test $arg -ge ${selector%-}
841                                 then
842                                         include=$positive
843                                 fi
844                                 ;;
845                         *-*)
846                                 if test ${selector%%-*} -le $arg \
847                                         && test $arg -le ${selector#*-}
848                                 then
849                                         include=$positive
850                                 fi
851                                 ;;
852                         *)
853                                 if test $arg -eq $selector
854                                 then
855                                         include=$positive
856                                 fi
857                                 ;;
858                 esac
859         done
860
861         test -n "$include"
862 }
863
864 maybe_teardown_verbose () {
865         test -z "$verbose_only" && return
866         exec 4>/dev/null 3>/dev/null
867         verbose=
868 }
869
870 last_verbose=t
871 maybe_setup_verbose () {
872         test -z "$verbose_only" && return
873         if match_pattern_list $test_count $verbose_only
874         then
875                 exec 4>&2 3>&1
876                 # Emit a delimiting blank line when going from
877                 # non-verbose to verbose.  Within verbose mode the
878                 # delimiter is printed by test_expect_*.  The choice
879                 # of the initial $last_verbose is such that before
880                 # test 1, we do not print it.
881                 test -z "$last_verbose" && echo >&3 ""
882                 verbose=t
883         else
884                 exec 4>/dev/null 3>/dev/null
885                 verbose=
886         fi
887         last_verbose=$verbose
888 }
889
890 maybe_teardown_valgrind () {
891         test -z "$GIT_VALGRIND" && return
892         GIT_VALGRIND_ENABLED=
893 }
894
895 maybe_setup_valgrind () {
896         test -z "$GIT_VALGRIND" && return
897         if test -z "$valgrind_only"
898         then
899                 GIT_VALGRIND_ENABLED=t
900                 return
901         fi
902         GIT_VALGRIND_ENABLED=
903         if match_pattern_list $test_count $valgrind_only
904         then
905                 GIT_VALGRIND_ENABLED=t
906         fi
907 }
908
909 trace_level_=0
910 want_trace () {
911         test "$trace" = t && {
912                 test "$verbose" = t || test "$verbose_log" = t
913         }
914 }
915
916 # This is a separate function because some tests use
917 # "return" to end a test_expect_success block early
918 # (and we want to make sure we run any cleanup like
919 # "set +x").
920 test_eval_inner_ () {
921         # Do not add anything extra (including LF) after '$*'
922         eval "
923                 want_trace && trace_level_=$(($trace_level_+1)) && set -x
924                 $*"
925 }
926
927 test_eval_ () {
928         # If "-x" tracing is in effect, then we want to avoid polluting stderr
929         # with non-test commands. But once in "set -x" mode, we cannot prevent
930         # the shell from printing the "set +x" to turn it off (nor the saving
931         # of $? before that). But we can make sure that the output goes to
932         # /dev/null.
933         #
934         # There are a few subtleties here:
935         #
936         #   - we have to redirect descriptor 4 in addition to 2, to cover
937         #     BASH_XTRACEFD
938         #
939         #   - the actual eval has to come before the redirection block (since
940         #     it needs to see descriptor 4 to set up its stderr)
941         #
942         #   - likewise, any error message we print must be outside the block to
943         #     access descriptor 4
944         #
945         #   - checking $? has to come immediately after the eval, but it must
946         #     be _inside_ the block to avoid polluting the "set -x" output
947         #
948
949         test_eval_inner_ "$@" </dev/null >&3 2>&4
950         {
951                 test_eval_ret_=$?
952                 if want_trace
953                 then
954                         test 1 = $trace_level_ && set +x
955                         trace_level_=$(($trace_level_-1))
956                 fi
957         } 2>/dev/null 4>&2
958
959         if test "$test_eval_ret_" != 0 && want_trace
960         then
961                 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
962         fi
963         return $test_eval_ret_
964 }
965
966 test_run_ () {
967         test_cleanup=:
968         expecting_failure=$2
969
970         if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
971                 # turn off tracing for this test-eval, as it simply creates
972                 # confusing noise in the "-x" output
973                 trace_tmp=$trace
974                 trace=
975                 # 117 is magic because it is unlikely to match the exit
976                 # code of other programs
977                 if $(printf '%s\n' "$1" | sed -f "$GIT_BUILD_DIR/t/chainlint.sed" | grep -q '?![A-Z][A-Z]*?!') ||
978                         test "OK-117" != "$(test_eval_ "(exit 117) && $1${LF}${LF}echo OK-\$?" 3>&1)"
979                 then
980                         BUG "broken &&-chain or run-away HERE-DOC: $1"
981                 fi
982                 trace=$trace_tmp
983         fi
984
985         setup_malloc_check
986         test_eval_ "$1"
987         eval_ret=$?
988         teardown_malloc_check
989
990         if test -z "$immediate" || test $eval_ret = 0 ||
991            test -n "$expecting_failure" && test "$test_cleanup" != ":"
992         then
993                 setup_malloc_check
994                 test_eval_ "$test_cleanup"
995                 teardown_malloc_check
996         fi
997         if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
998         then
999                 echo ""
1000         fi
1001         return "$eval_ret"
1002 }
1003
1004 test_start_ () {
1005         test_count=$(($test_count+1))
1006         maybe_setup_verbose
1007         maybe_setup_valgrind
1008         if test -n "$write_junit_xml"
1009         then
1010                 junit_start=$(test-tool date getnanos)
1011         fi
1012 }
1013
1014 test_finish_ () {
1015         echo >&3 ""
1016         maybe_teardown_valgrind
1017         maybe_teardown_verbose
1018         if test -n "$GIT_TEST_TEE_OFFSET"
1019         then
1020                 GIT_TEST_TEE_OFFSET=$(test-tool path-utils file-size \
1021                         "$GIT_TEST_TEE_OUTPUT_FILE")
1022         fi
1023 }
1024
1025 test_skip () {
1026         to_skip=
1027         skipped_reason=
1028         if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
1029         then
1030                 to_skip=t
1031                 skipped_reason="GIT_SKIP_TESTS"
1032         fi
1033         if test -z "$to_skip" && test -n "$run_list" &&
1034            ! match_test_selector_list '--run' $test_count "$run_list"
1035         then
1036                 to_skip=t
1037                 skipped_reason="--run"
1038         fi
1039         if test -z "$to_skip" && test -n "$test_prereq" &&
1040            ! test_have_prereq "$test_prereq"
1041         then
1042                 to_skip=t
1043
1044                 of_prereq=
1045                 if test "$missing_prereq" != "$test_prereq"
1046                 then
1047                         of_prereq=" of $test_prereq"
1048                 fi
1049                 skipped_reason="missing $missing_prereq${of_prereq}"
1050         fi
1051
1052         case "$to_skip" in
1053         t)
1054                 if test -n "$write_junit_xml"
1055                 then
1056                         message="$(xml_attr_encode "$skipped_reason")"
1057                         write_junit_xml_testcase "$1" \
1058                                 "      <skipped message=\"$message\" />"
1059                 fi
1060
1061                 say_color skip >&3 "skipping test: $@"
1062                 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
1063                 : true
1064                 ;;
1065         *)
1066                 false
1067                 ;;
1068         esac
1069 }
1070
1071 # stub; perf-lib overrides it
1072 test_at_end_hook_ () {
1073         :
1074 }
1075
1076 write_junit_xml () {
1077         case "$1" in
1078         --truncate)
1079                 >"$junit_xml_path"
1080                 junit_have_testcase=
1081                 shift
1082                 ;;
1083         esac
1084         printf '%s\n' "$@" >>"$junit_xml_path"
1085 }
1086
1087 xml_attr_encode () {
1088         printf '%s\n' "$@" | test-tool xml-encode
1089 }
1090
1091 write_junit_xml_testcase () {
1092         junit_attrs="name=\"$(xml_attr_encode "$this_test.$test_count $1")\""
1093         shift
1094         junit_attrs="$junit_attrs classname=\"$this_test\""
1095         junit_attrs="$junit_attrs time=\"$(test-tool \
1096                 date getnanos $junit_start)\""
1097         write_junit_xml "$(printf '%s\n' \
1098                 "    <testcase $junit_attrs>" "$@" "    </testcase>")"
1099         junit_have_testcase=t
1100 }
1101
1102 finalize_junit_xml () {
1103         if test -n "$write_junit_xml" && test -n "$junit_xml_path"
1104         then
1105                 test -n "$junit_have_testcase" || {
1106                         junit_start=$(test-tool date getnanos)
1107                         write_junit_xml_testcase "all tests skipped"
1108                 }
1109
1110                 # adjust the overall time
1111                 junit_time=$(test-tool date getnanos $junit_suite_start)
1112                 sed -e "s/\(<testsuite.*\) time=\"[^\"]*\"/\1/" \
1113                         -e "s/<testsuite [^>]*/& time=\"$junit_time\"/" \
1114                         -e '/^ *<\/testsuite/d' \
1115                         <"$junit_xml_path" >"$junit_xml_path.new"
1116                 mv "$junit_xml_path.new" "$junit_xml_path"
1117
1118                 write_junit_xml "  </testsuite>" "</testsuites>"
1119                 write_junit_xml=
1120         fi
1121 }
1122
1123 test_atexit_cleanup=:
1124 test_atexit_handler () {
1125         # In a succeeding test script 'test_atexit_handler' is invoked
1126         # twice: first from 'test_done', then from 'die' in the trap on
1127         # EXIT.
1128         # This condition and resetting 'test_atexit_cleanup' below makes
1129         # sure that the registered cleanup commands are run only once.
1130         test : != "$test_atexit_cleanup" || return 0
1131
1132         setup_malloc_check
1133         test_eval_ "$test_atexit_cleanup"
1134         test_atexit_cleanup=:
1135         teardown_malloc_check
1136 }
1137
1138 test_done () {
1139         GIT_EXIT_OK=t
1140
1141         # Run the atexit commands _before_ the trash directory is
1142         # removed, so the commands can access pidfiles and socket files.
1143         test_atexit_handler
1144
1145         finalize_junit_xml
1146
1147         if test -z "$HARNESS_ACTIVE"
1148         then
1149                 mkdir -p "$TEST_RESULTS_DIR"
1150
1151                 cat >"$TEST_RESULTS_BASE.counts" <<-EOF
1152                 total $test_count
1153                 success $test_success
1154                 fixed $test_fixed
1155                 broken $test_broken
1156                 failed $test_failure
1157
1158                 EOF
1159         fi
1160
1161         if test "$test_fixed" != 0
1162         then
1163                 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
1164         fi
1165         if test "$test_broken" != 0
1166         then
1167                 say_color warn "# still have $test_broken known breakage(s)"
1168         fi
1169         if test "$test_broken" != 0 || test "$test_fixed" != 0
1170         then
1171                 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
1172                 msg="remaining $test_remaining test(s)"
1173         else
1174                 test_remaining=$test_count
1175                 msg="$test_count test(s)"
1176         fi
1177         case "$test_failure" in
1178         0)
1179                 if test $test_external_has_tap -eq 0
1180                 then
1181                         if test $test_remaining -gt 0
1182                         then
1183                                 say_color pass "# passed all $msg"
1184                         fi
1185
1186                         # Maybe print SKIP message
1187                         test -z "$skip_all" || skip_all="# SKIP $skip_all"
1188                         case "$test_count" in
1189                         0)
1190                                 say "1..$test_count${skip_all:+ $skip_all}"
1191                                 ;;
1192                         *)
1193                                 test -z "$skip_all" ||
1194                                 say_color warn "$skip_all"
1195                                 say "1..$test_count"
1196                                 ;;
1197                         esac
1198                 fi
1199
1200                 if test -z "$debug"
1201                 then
1202                         test -d "$TRASH_DIRECTORY" ||
1203                         error "Tests passed but trash directory already removed before test cleanup; aborting"
1204
1205                         cd "$TRASH_DIRECTORY/.." &&
1206                         rm -fr "$TRASH_DIRECTORY" || {
1207                                 # try again in a bit
1208                                 sleep 5;
1209                                 rm -fr "$TRASH_DIRECTORY"
1210                         } ||
1211                         error "Tests passed but test cleanup failed; aborting"
1212                 fi
1213                 test_at_end_hook_
1214
1215                 exit 0 ;;
1216
1217         *)
1218                 if test $test_external_has_tap -eq 0
1219                 then
1220                         say_color error "# failed $test_failure among $msg"
1221                         say "1..$test_count"
1222                 fi
1223
1224                 exit 1 ;;
1225
1226         esac
1227 }
1228
1229 if test -n "$valgrind"
1230 then
1231         make_symlink () {
1232                 test -h "$2" &&
1233                 test "$1" = "$(readlink "$2")" || {
1234                         # be super paranoid
1235                         if mkdir "$2".lock
1236                         then
1237                                 rm -f "$2" &&
1238                                 ln -s "$1" "$2" &&
1239                                 rm -r "$2".lock
1240                         else
1241                                 while test -d "$2".lock
1242                                 do
1243                                         say "Waiting for lock on $2."
1244                                         sleep 1
1245                                 done
1246                         fi
1247                 }
1248         }
1249
1250         make_valgrind_symlink () {
1251                 # handle only executables, unless they are shell libraries that
1252                 # need to be in the exec-path.
1253                 test -x "$1" ||
1254                 test "# " = "$(test_copy_bytes 2 <"$1")" ||
1255                 return;
1256
1257                 base=$(basename "$1")
1258                 case "$base" in
1259                 test-*)
1260                         symlink_target="$GIT_BUILD_DIR/t/helper/$base"
1261                         ;;
1262                 *)
1263                         symlink_target="$GIT_BUILD_DIR/$base"
1264                         ;;
1265                 esac
1266                 # do not override scripts
1267                 if test -x "$symlink_target" &&
1268                     test ! -d "$symlink_target" &&
1269                     test "#!" != "$(test_copy_bytes 2 <"$symlink_target")"
1270                 then
1271                         symlink_target=../valgrind.sh
1272                 fi
1273                 case "$base" in
1274                 *.sh|*.perl)
1275                         symlink_target=../unprocessed-script
1276                 esac
1277                 # create the link, or replace it if it is out of date
1278                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
1279         }
1280
1281         # override all git executables in TEST_DIRECTORY/..
1282         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
1283         mkdir -p "$GIT_VALGRIND"/bin
1284         for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-*
1285         do
1286                 make_valgrind_symlink $file
1287         done
1288         # special-case the mergetools loadables
1289         make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
1290         OLDIFS=$IFS
1291         IFS=:
1292         for path in $PATH
1293         do
1294                 ls "$path"/git-* 2> /dev/null |
1295                 while read file
1296                 do
1297                         make_valgrind_symlink "$file"
1298                 done
1299         done
1300         IFS=$OLDIFS
1301         PATH=$GIT_VALGRIND/bin:$PATH
1302         GIT_EXEC_PATH=$GIT_VALGRIND/bin
1303         export GIT_VALGRIND
1304         GIT_VALGRIND_MODE="$valgrind"
1305         export GIT_VALGRIND_MODE
1306         GIT_VALGRIND_ENABLED=t
1307         test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
1308         export GIT_VALGRIND_ENABLED
1309 elif test -n "$GIT_TEST_INSTALLED"
1310 then
1311         GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
1312         error "Cannot run git from $GIT_TEST_INSTALLED."
1313         PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR/t/helper:$PATH
1314         GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
1315 else # normal case, use ../bin-wrappers only unless $with_dashes:
1316         if test -n "$no_bin_wrappers"
1317         then
1318                 with_dashes=t
1319         else
1320                 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
1321                 if ! test -x "$git_bin_dir/git"
1322                 then
1323                         if test -z "$with_dashes"
1324                         then
1325                                 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
1326                         fi
1327                         with_dashes=t
1328                 fi
1329                 PATH="$git_bin_dir:$PATH"
1330         fi
1331         GIT_EXEC_PATH=$GIT_BUILD_DIR
1332         if test -n "$with_dashes"
1333         then
1334                 PATH="$GIT_BUILD_DIR:$GIT_BUILD_DIR/t/helper:$PATH"
1335         fi
1336 fi
1337 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
1338 GIT_CONFIG_NOSYSTEM=1
1339 GIT_ATTR_NOSYSTEM=1
1340 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
1341
1342 if test -z "$GIT_TEST_CMP"
1343 then
1344         if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
1345         then
1346                 GIT_TEST_CMP="$DIFF -c"
1347         else
1348                 GIT_TEST_CMP="$DIFF -u"
1349         fi
1350 fi
1351
1352 GITPERLLIB="$GIT_BUILD_DIR"/perl/build/lib
1353 export GITPERLLIB
1354 test -d "$GIT_BUILD_DIR"/templates/blt || {
1355         error "You haven't built things yet, have you?"
1356 }
1357
1358 if ! test -x "$GIT_BUILD_DIR"/t/helper/test-tool$X
1359 then
1360         echo >&2 'You need to build test-tool:'
1361         echo >&2 'Run "make t/helper/test-tool" in the source (toplevel) directory'
1362         exit 1
1363 fi
1364
1365 # Test repository
1366 rm -fr "$TRASH_DIRECTORY" || {
1367         GIT_EXIT_OK=t
1368         echo >&5 "FATAL: Cannot prepare test area"
1369         exit 1
1370 }
1371
1372 HOME="$TRASH_DIRECTORY"
1373 GNUPGHOME="$HOME/gnupg-home-not-used"
1374 export HOME GNUPGHOME
1375
1376 if test -z "$TEST_NO_CREATE_REPO"
1377 then
1378         test_create_repo "$TRASH_DIRECTORY"
1379 else
1380         mkdir -p "$TRASH_DIRECTORY"
1381 fi
1382
1383 # Use -P to resolve symlinks in our working directory so that the cwd
1384 # in subprocesses like git equals our $PWD (for pathname comparisons).
1385 cd -P "$TRASH_DIRECTORY" || exit 1
1386
1387 this_test=${0##*/}
1388 this_test=${this_test%%-*}
1389 if match_pattern_list "$this_test" $GIT_SKIP_TESTS
1390 then
1391         say_color info >&3 "skipping test $this_test altogether"
1392         skip_all="skip all tests in $this_test"
1393         test_done
1394 fi
1395
1396 if test -n "$write_junit_xml"
1397 then
1398         junit_xml_dir="$TEST_OUTPUT_DIRECTORY/out"
1399         mkdir -p "$junit_xml_dir"
1400         junit_xml_base=${0##*/}
1401         junit_xml_path="$junit_xml_dir/TEST-${junit_xml_base%.sh}.xml"
1402         junit_attrs="name=\"${junit_xml_base%.sh}\""
1403         junit_attrs="$junit_attrs timestamp=\"$(TZ=UTC \
1404                 date +%Y-%m-%dT%H:%M:%S)\""
1405         write_junit_xml --truncate "<testsuites>" "  <testsuite $junit_attrs>"
1406         junit_suite_start=$(test-tool date getnanos)
1407         if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
1408         then
1409                 GIT_TEST_TEE_OFFSET=0
1410         fi
1411 fi
1412
1413 # Convenience
1414 # A regexp to match 5, 35 and 40 hexdigits
1415 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
1416 _x35="$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
1417 _x40="$_x35$_x05"
1418
1419 test_oid_init
1420
1421 ZERO_OID=$(test_oid zero)
1422 OID_REGEX=$(echo $ZERO_OID | sed -e 's/0/[0-9a-f]/g')
1423 OIDPATH_REGEX=$(test_oid_to_path $ZERO_OID | sed -e 's/0/[0-9a-f]/g')
1424 EMPTY_TREE=$(test_oid empty_tree)
1425 EMPTY_BLOB=$(test_oid empty_blob)
1426 _z40=$ZERO_OID
1427
1428 # Provide an implementation of the 'yes' utility; the upper bound
1429 # limit is there to help Windows that cannot stop this loop from
1430 # wasting cycles when the downstream stops reading, so do not be
1431 # tempted to turn it into an infinite loop. cf. 6129c930 ("test-lib:
1432 # limit the output of the yes utility", 2016-02-02)
1433 yes () {
1434         if test $# = 0
1435         then
1436                 y=y
1437         else
1438                 y="$*"
1439         fi
1440
1441         i=0
1442         while test $i -lt 99
1443         do
1444                 echo "$y"
1445                 i=$(($i+1))
1446         done
1447 }
1448
1449 # The GIT_TEST_FAIL_PREREQS code hooks into test_set_prereq(), and
1450 # thus needs to be set up really early, and set an internal variable
1451 # for convenience so the hot test_set_prereq() codepath doesn't need
1452 # to call "git env--helper" (via test_bool_env). Only do that work
1453 # if needed by seeing if GIT_TEST_FAIL_PREREQS is set at all.
1454 GIT_TEST_FAIL_PREREQS_INTERNAL=
1455 if test -n "$GIT_TEST_FAIL_PREREQS"
1456 then
1457         if test_bool_env GIT_TEST_FAIL_PREREQS false
1458         then
1459                 GIT_TEST_FAIL_PREREQS_INTERNAL=true
1460                 test_set_prereq FAIL_PREREQS
1461         fi
1462 else
1463         test_lazy_prereq FAIL_PREREQS '
1464                 test_bool_env GIT_TEST_FAIL_PREREQS false
1465         '
1466 fi
1467
1468 # Fix some commands on Windows, and other OS-specific things
1469 uname_s=$(uname -s)
1470 case $uname_s in
1471 *MINGW*)
1472         # Windows has its own (incompatible) sort and find
1473         sort () {
1474                 /usr/bin/sort "$@"
1475         }
1476         find () {
1477                 /usr/bin/find "$@"
1478         }
1479         # git sees Windows-style pwd
1480         pwd () {
1481                 builtin pwd -W
1482         }
1483         # no POSIX permissions
1484         # backslashes in pathspec are converted to '/'
1485         # exec does not inherit the PID
1486         test_set_prereq MINGW
1487         test_set_prereq NATIVE_CRLF
1488         test_set_prereq SED_STRIPS_CR
1489         test_set_prereq GREP_STRIPS_CR
1490         GIT_TEST_CMP=mingw_test_cmp
1491         ;;
1492 *CYGWIN*)
1493         test_set_prereq POSIXPERM
1494         test_set_prereq EXECKEEPSPID
1495         test_set_prereq CYGWIN
1496         test_set_prereq SED_STRIPS_CR
1497         test_set_prereq GREP_STRIPS_CR
1498         ;;
1499 *)
1500         test_set_prereq POSIXPERM
1501         test_set_prereq BSLASHPSPEC
1502         test_set_prereq EXECKEEPSPID
1503         ;;
1504 esac
1505
1506 # Detect arches where a few things don't work
1507 uname_m=$(uname -m)
1508 case $uname_m in
1509 parisc* | hppa*)
1510         test_set_prereq HPPA
1511         ;;
1512 esac
1513
1514 ( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1515 test -z "$NO_PERL" && test_set_prereq PERL
1516 test -z "$NO_PTHREADS" && test_set_prereq PTHREADS
1517 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1518 test -n "$USE_LIBPCRE1$USE_LIBPCRE2" && test_set_prereq PCRE
1519 test -n "$USE_LIBPCRE1" && test_set_prereq LIBPCRE1
1520 test -n "$USE_LIBPCRE2" && test_set_prereq LIBPCRE2
1521 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1522
1523 if test -n "$GIT_TEST_GETTEXT_POISON_ORIG"
1524 then
1525         GIT_TEST_GETTEXT_POISON=$GIT_TEST_GETTEXT_POISON_ORIG
1526         export GIT_TEST_GETTEXT_POISON
1527         unset GIT_TEST_GETTEXT_POISON_ORIG
1528 fi
1529
1530 test_lazy_prereq C_LOCALE_OUTPUT '
1531         ! test_bool_env GIT_TEST_GETTEXT_POISON false
1532 '
1533
1534 if test -z "$GIT_TEST_CHECK_CACHE_TREE"
1535 then
1536         GIT_TEST_CHECK_CACHE_TREE=true
1537         export GIT_TEST_CHECK_CACHE_TREE
1538 fi
1539
1540 test_lazy_prereq PIPE '
1541         # test whether the filesystem supports FIFOs
1542         test_have_prereq !MINGW,!CYGWIN &&
1543         rm -f testfifo && mkfifo testfifo
1544 '
1545
1546 test_lazy_prereq SYMLINKS '
1547         # test whether the filesystem supports symbolic links
1548         ln -s x y && test -h y
1549 '
1550
1551 test_lazy_prereq FILEMODE '
1552         test "$(git config --bool core.filemode)" = true
1553 '
1554
1555 test_lazy_prereq CASE_INSENSITIVE_FS '
1556         echo good >CamelCase &&
1557         echo bad >camelcase &&
1558         test "$(cat CamelCase)" != good
1559 '
1560
1561 test_lazy_prereq FUNNYNAMES '
1562         test_have_prereq !MINGW &&
1563         touch -- \
1564                 "FUNNYNAMES tab embedded" \
1565                 "FUNNYNAMES \"quote embedded\"" \
1566                 "FUNNYNAMES newline
1567 embedded" 2>/dev/null &&
1568         rm -- \
1569                 "FUNNYNAMES tab embedded" \
1570                 "FUNNYNAMES \"quote embedded\"" \
1571                 "FUNNYNAMES newline
1572 embedded" 2>/dev/null
1573 '
1574
1575 test_lazy_prereq UTF8_NFD_TO_NFC '
1576         # check whether FS converts nfd unicode to nfc
1577         auml=$(printf "\303\244")
1578         aumlcdiar=$(printf "\141\314\210")
1579         >"$auml" &&
1580         test -f "$aumlcdiar"
1581 '
1582
1583 test_lazy_prereq AUTOIDENT '
1584         sane_unset GIT_AUTHOR_NAME &&
1585         sane_unset GIT_AUTHOR_EMAIL &&
1586         git var GIT_AUTHOR_IDENT
1587 '
1588
1589 test_lazy_prereq EXPENSIVE '
1590         test -n "$GIT_TEST_LONG"
1591 '
1592
1593 test_lazy_prereq EXPENSIVE_ON_WINDOWS '
1594         test_have_prereq EXPENSIVE || test_have_prereq !MINGW,!CYGWIN
1595 '
1596
1597 test_lazy_prereq USR_BIN_TIME '
1598         test -x /usr/bin/time
1599 '
1600
1601 test_lazy_prereq NOT_ROOT '
1602         uid=$(id -u) &&
1603         test "$uid" != 0
1604 '
1605
1606 test_lazy_prereq JGIT '
1607         jgit --version
1608 '
1609
1610 # SANITY is about "can you correctly predict what the filesystem would
1611 # do by only looking at the permission bits of the files and
1612 # directories?"  A typical example of !SANITY is running the test
1613 # suite as root, where a test may expect "chmod -r file && cat file"
1614 # to fail because file is supposed to be unreadable after a successful
1615 # chmod.  In an environment (i.e. combination of what filesystem is
1616 # being used and who is running the tests) that lacks SANITY, you may
1617 # be able to delete or create a file when the containing directory
1618 # doesn't have write permissions, or access a file even if the
1619 # containing directory doesn't have read or execute permissions.
1620
1621 test_lazy_prereq SANITY '
1622         mkdir SANETESTD.1 SANETESTD.2 &&
1623
1624         chmod +w SANETESTD.1 SANETESTD.2 &&
1625         >SANETESTD.1/x 2>SANETESTD.2/x &&
1626         chmod -w SANETESTD.1 &&
1627         chmod -r SANETESTD.1/x &&
1628         chmod -rx SANETESTD.2 ||
1629         BUG "cannot prepare SANETESTD"
1630
1631         ! test -r SANETESTD.1/x &&
1632         ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1633         status=$?
1634
1635         chmod +rwx SANETESTD.1 SANETESTD.2 &&
1636         rm -rf SANETESTD.1 SANETESTD.2 ||
1637         BUG "cannot clean SANETESTD"
1638         return $status
1639 '
1640
1641 test FreeBSD != $uname_s || GIT_UNZIP=${GIT_UNZIP:-/usr/local/bin/unzip}
1642 GIT_UNZIP=${GIT_UNZIP:-unzip}
1643 test_lazy_prereq UNZIP '
1644         "$GIT_UNZIP" -v
1645         test $? -ne 127
1646 '
1647
1648 run_with_limited_cmdline () {
1649         (ulimit -s 128 && "$@")
1650 }
1651
1652 test_lazy_prereq CMDLINE_LIMIT '
1653         test_have_prereq !HPPA,!MINGW,!CYGWIN &&
1654         run_with_limited_cmdline true
1655 '
1656
1657 run_with_limited_stack () {
1658         (ulimit -s 128 && "$@")
1659 }
1660
1661 test_lazy_prereq ULIMIT_STACK_SIZE '
1662         test_have_prereq !HPPA,!MINGW,!CYGWIN &&
1663         run_with_limited_stack true
1664 '
1665
1666 run_with_limited_open_files () {
1667         (ulimit -n 32 && "$@")
1668 }
1669
1670 test_lazy_prereq ULIMIT_FILE_DESCRIPTORS '
1671         test_have_prereq !MINGW,!CYGWIN &&
1672         run_with_limited_open_files true
1673 '
1674
1675 build_option () {
1676         git version --build-options |
1677         sed -ne "s/^$1: //p"
1678 }
1679
1680 test_lazy_prereq LONG_IS_64BIT '
1681         test 8 -le "$(build_option sizeof-long)"
1682 '
1683
1684 test_lazy_prereq TIME_IS_64BIT 'test-tool date is64bit'
1685 test_lazy_prereq TIME_T_IS_64BIT 'test-tool date time_t-is64bit'
1686
1687 test_lazy_prereq CURL '
1688         curl --version
1689 '
1690
1691 # SHA1 is a test if the hash algorithm in use is SHA-1.  This is both for tests
1692 # which will not work with other hash algorithms and tests that work but don't
1693 # test anything meaningful (e.g. special values which cause short collisions).
1694 test_lazy_prereq SHA1 '
1695         case "$GIT_DEFAULT_HASH" in
1696         sha1) true ;;
1697         "") test $(git hash-object /dev/null) = e69de29bb2d1d6434b8b29ae775ad8c2e48c5391 ;;
1698         *) false ;;
1699         esac
1700 '
1701
1702 test_lazy_prereq REBASE_P '
1703         test -z "$GIT_TEST_SKIP_REBASE_P"
1704 '